#pragma once
#include "d3dx9.h"
#include "mmsystem.h"

#include "DataInMem.h"
#include "MState.h"

/*
GGame Ŭ

ӿ  ̰  κ Ѵ.
*/

class GGame
{
protected:
	LPDIRECT3D9 m_pd3d;
	LPDIRECT3DDEVICE9 m_pd3dd;
	LPD3DXSPRITE m_pspr;
	LPD3DXLINE m_pline;
	MState* m_pstate;
	MState* m_pnewstate;
	bool m_stateinit;
	bool m_activated;
	BYTE m_keystate[256];
	POINT m_cursorpos;
	bool m_drawskip;
	DWORD m_time;
	D3DPRESENT_PARAMETERS _getdpp();
	void OnCreate();
	void OnProc();
	void OnDraw();
	void OnPostProc();
	void OnLost();
	void OnReset();
	void OnDrawSkip();
	void InitRenderState();
	GGame();/*
			ڸ protected  , GGame Ŭ ܺο
			νϽ   . ׷Ƿ GGame Ϸ,
			νϽ   GetInstance()  GGame* 
			ؾ Ѵ.
			*/
	~GGame();
public:
	struct {
		D3DDEVTYPE d3ddt;
		BOOL fullscreen;
		UINT width,height;
		D3DSWAPEFFECT d3dse;
		D3DFORMAT backformat;
		D3DFORMAT stencilformat;
		UINT buffercount;
		UINT _size;
		UINT refreshrate;
		HWND hwnd;
	}m_dev; /*
			Direct3Dġ Ӽ ش.
			*/
	enum{
		DM_Normal=0,
		DM_NoBlend,
		DM_Add,
		DM_Subtract,
		DM_Multiply,
	};/*
	  SetDrawModeԼ ù° ڷ ȴ.
	  */
	enum{
		DM_Red=D3DCOLORWRITEENABLE_RED,
		DM_Green=D3DCOLORWRITEENABLE_GREEN,
		DM_Blue=D3DCOLORWRITEENABLE_BLUE,
		DM_Alpha=D3DCOLORWRITEENABLE_ALPHA,
	};/*
	  SetDrawModeԼ ι° ڷ ȴ.
	  */
	enum{
		KS_Pressed=1,
		KS_Down=2,
		KS_Up=4,
	};/*
	  GetKeyStateԼ ϰ ȴ.
	  */
	static GGame* GetInstance();
	/*
	GGame  νϽ   ִ  Լ̴.
	*/
	LPDIRECT3DDEVICE9 GetDevice();
	LPD3DXSPRITE GetSprite();
	GRET SetState(MState* newstate);
	GRET ReleaseState();
	GRET Create3DDevice(HWND hWnd);
	GRET Release3D();
	GRET Reset3DDevice();
	GRET MessageLoop();
	LRESULT MsgProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	GRET SetDrawMode(int mode, int cmode=DM_Red | DM_Green | DM_Blue | DM_Alpha);
	GRET DrawLine(int x1, int y1, int x2, int y2, D3DCOLOR color);
	GRET SetLineWidth(int w);
	GRET DrawRectangle(int x, int y, int w, int h, D3DCOLOR color);
	GRET DrawRectangle(int x, int y, int w, int h,
		D3DCOLOR color1, D3DCOLOR color2, D3DCOLOR color3, D3DCOLOR color4);
	GRET SetDrawSkip(bool skip);
	bool GetDrawSkip();
};