#pragma once

#include "MState.h"
#include "GObject.h"
#include "GSprites.h"

class MPlayGame;

/*
MPlayGame Ŭ (MState Ŭ )

  ÷ϰ ִ ¸ óѴ.
*/
class MPlayGame : public MState
{
protected:
	struct{
		POINT frame;
		POINT key[5];
		POINT notelt;
		POINT noterb;
		POINT hpbar;
		POINT hpbarminmax;
	}m_ui;
	vector<BYTE> m_codedata;
	GObject m_objframe;
	GObject m_button[5];
	GObject m_hpbar;
	int m_buttonkeycode[5];
	int m_hp;
	int m_maxhp;
	GSprites m_sprs;
	GFont m_gfont;
	enum{
		Event_Frame=0,
		Event_Button1Down,
		Event_Button5Down=Event_Button1Down+4,
		Event_Button1Up,
		Event_Button5Up=Event_Button1Up+4,
		Event_HPBar,
	};
	inline int GetButton(int KeyCode);
	inline void ButtonDown(int Button);
	inline void ButtonUp(int Button);
public:
	MPlayGame();	
	~MPlayGame();
	void OnCreate();
	void OnProc(DWORD ElapsedTime);
	void OnDraw();
	void OnPostProc();
	void OnLost();
	void OnReset();
	void OnKeyDown(int KeyCode);
	void OnKeyUp(int KeyCode);
	void OnDrawSkip();
	GRET LoadOC(DataInMem* file);

};
