#include <stdio.h>
#include <vector>
#include <string>
using namespace std;

void convert(const char* input, const char* output)
{
    FILE* file=fopen(input, "r");
    vector<wstring> vspr;
    while(!feof(file))
    {
        wchar_t temp[256];
        fgetws(temp, 256, file);
        vspr.push_back(temp);
    }
    fclose(file);
    file=fopen(output, "wb");
    unsigned long num=vspr.size();
    fwrite(&num, 4, 1, file);
    for(unsigned long i=0;i<num;i++)
    {
        if(vspr[i][vspr[i].size()-1]==L'\n')vspr[i].erase(vspr[i].size()-1);
        unsigned long len=vspr[i].size();
        fwrite(&len, 4, 1, file);
        fwrite(vspr[i].c_str(), len, 2, file);
    }
    fclose(file);
}

int main(int argc, char** argv)
{
    if(argc==1)
    {
        char input[32];
        char output[32];
        printf("Input file: ");
        scanf("%31s", input);
        printf("Output file: ");
        scanf("%31s", output);
        convert(input, output);
    }
    else if(argc==2)
    {
        char output[32];
        printf("Output file: ");
        scanf("%31s", output);
        convert(argv[1], output);
    }
    else
    {
        convert(argv[1], argv[2]);
    }
    return 0;
}
